#include "StdAfx.h"
#include "global.h"
#include "inbuffer.h"
#include <cmath>

#define SCOM_CUMMULATIVE_BUFFER_SIZE 165000
#define SCOM_INPUT_BUFFER_SIZE 2000

double stvls[16]={0};
double avvls[16]={0};
long avsmp[16]={0};

UINT InBufferFunctionThread(LPVOID pParam)
{

	InBuffer * minbuffer = (InBuffer *) pParam;
	CString m_error;
	int a,b,my_status;
	int rsz=0;
	unsigned char readbuffer[SCOM_INPUT_BUFFER_SIZE];
	CSingleLock slock(&scomm_mutex);
	CSingleLock block(&inbuffer_mutex);
	CSingleLock mlock(&ui_mutex);

	while(1)
	{
		mlock.Lock();
		b=minbuffer->mywch->terminate;
		mlock.Unlock();
		if(b)
			AfxEndThread(0);
		slock.Lock();
		my_status=minbuffer->my_scomm->Status();
		slock.Unlock();
		if(my_status)
		{
			//rsz=1;
			//while(rsz>0)
			//{
			m_error="";
			slock.Lock();
			rsz=minbuffer->my_scomm->Read(readbuffer,m_error);
			slock.Unlock();
			block.Lock();
			minbuffer->Put(readbuffer,rsz);
			block.Unlock();
			if(rsz>0)
			{
				m_error+="Read:";
				CString metm;
				for(int k=0;k<rsz;k++)
				{

					metm.Format("%d ",readbuffer[k]);
					m_error+=metm;
				}
				m_error+="\r\n";
			}
			if(m_error!="")
			{
				mlock.Lock();
				minbuffer->mywch->AddLogM(m_error);
				mlock.Unlock();
			}
			//}
			//Parse out stuff here autmatically and periodically.
			//start with command errors
			a=1;
			while(a!=PARSE_NOT_FOUND)
			{
				block.Lock();
				a=minbuffer->ParseForAndRemove(RESPONSE_ERROR,readbuffer,rsz);
				block.Unlock();
				if(a!=PARSE_NOT_FOUND)
				{
					m_error="Response Error:";
					CString cp="",qp="",qc="";
					for(int k=1;k<rsz;k++)
					{
						qp.Format("%c",readbuffer[k]);
						cp.Format("%d ",readbuffer[k]);
						qc+=qp;
						m_error+=cp;
					}
					m_error+=" (";
					m_error+=qc+")\r\n";
					mlock.Lock();
					minbuffer->mywch->AddLogM(m_error);
					mlock.Unlock();
				}
			}
			//successes
			a=1;
			while(a!=PARSE_NOT_FOUND)
			{
				block.Lock();
				a=minbuffer->ParseForAndRemove(RESPONSE_OK,readbuffer,rsz);
				block.Unlock();
				if(a!=PARSE_NOT_FOUND)
				{
					m_error="Response Success:";
					CString cp="",qp="",qc="";
					for(int k=1;k<rsz;k++)
					{
						qp.Format("%c",readbuffer[k]);
						cp.Format("%d ",readbuffer[k]);
						qc+=qp;
						m_error+=cp;
					}
					m_error+=" (";
					m_error+=qc+")\r\n";
					mlock.Lock();
					minbuffer->mywch->AddLogM(m_error);
					mlock.Unlock();
				}
			}
			//take out any values reported
			a=1;
			while(a!=PARSE_NOT_FOUND)
			{
				block.Lock();
				a=minbuffer->ParseForAndRemove(RESPONSE_VALUES,readbuffer,rsz);
				block.Unlock();
				if(a!=PARSE_NOT_FOUND)
				{
					m_error="Values Reported:";
					CString cp="";
					for(int k=1;k<rsz;k++)
					{
						cp.Format("%d ",readbuffer[k]);
						m_error+=cp;
					}
					m_error+="\r\n";
					mlock.Lock();
					minbuffer->mywch->AddLogM(m_error);
					mlock.Unlock();

					m_error="Values  Seq-nr:";
					cp.Format(" %d\r\n  ",readbuffer[1]);
					m_error+=cp;
					CString vls[16];
					CString vls_v[16];
					for(int k=0;k<16;k++)
					{
						vls[k]="";
						vls_v[k]="";
					}


					for(int k=2;k<rsz;k+=4)
					{
						int a = readbuffer[k+2];
						a<<=8;
						a+=readbuffer[k+1];
						cp.Format(" %d:%ld (%d)",readbuffer[k],a, readbuffer[k+3]);
						m_error+=cp;
						if(readbuffer[k]<16)
						{
							int abc=readbuffer[k];
							if(!avsmp[abc])
							{
								avvls[abc]=a;
							}
							else
							{								
								avvls[abc]+=a;
							}
							avsmp[abc]++;
							stvls[abc]+=(avvls[abc]/avsmp[abc]-a)*(avvls[abc]/avsmp[abc]-a);
							vls[readbuffer[k]].Format("%ld",a);
						}
					}
					m_error+="\r\n";
					mlock.Lock();
					minbuffer->mywch->AddLogC(m_error);
					if(minbuffer->mywch->AVG_BOX[0]=="-1")
					{
						for(k=0;k<16;k++)
						{
							avsmp[k]=0;
							stvls[k]=0;
							avvls[k]=0;
						}
					}
					for(int k=0;k<16; k++)
					{
						if(vls[k]!="")
						{
							minbuffer->mywch->disp_adc[k]=vls[k];
							minbuffer->mywch->AVG_BOX[k].Format("%4.4g",sqrt(stvls[k]/(avsmp[k]-1)));
						}
					}
					mlock.Unlock();
				}
			}
			//take out any comments coming back:
			a=1;
			while(a!=PARSE_NOT_FOUND)
			{
				block.Lock();
				a=minbuffer->ParseForAndRemove(RESPONSE_COMMENT,readbuffer,rsz);
				block.Unlock();
				if(a!=PARSE_NOT_FOUND)
				{
					m_error="";
					CString cp="";

					/* for(int k=1;k<rsz;k++)
					{
					cp.Format("%d ",readbuffer[k]);
					m_error+=cp;
					}
					m_error+="\r\n";
					mlock.Lock();
					minbuffer->mywch->AddLogT(m_error);
					mlock.Unlock(); */

					m_error="";
					cp="";
					for(int k=1;k<rsz;k++)
					{
						cp.Format("%c",readbuffer[k]);
						m_error+=cp;
					}

					m_error+="\r\n";
					mlock.Lock();
					minbuffer->mywch->AddLogT(m_error);
					mlock.Unlock();
				}
			}
		}
		if(!my_status)
			Sleep(COM_POLL_PERIOD);
	}
}

InBuffer::InBuffer()
{
	buffer = new unsigned char [SCOM_CUMMULATIVE_BUFFER_SIZE];
	bufferptr=0;
}

InBuffer::~InBuffer()
{
	delete buffer;
}

void InBuffer::Put(unsigned char * put_value, int how_much)
{
	for(int i=0;i<how_much;i++)
		buffer[i+bufferptr]=put_value[i];
	bufferptr+=how_much;
}

void InBuffer::Remove(int p_from, int p_to)
{
	for(int i=0;i+1+p_to<bufferptr;i++)
	{
		buffer[p_from+i]=buffer[p_to+1+i];
	}
	bufferptr-=(p_to+1-p_from); 
}

int InBuffer::ParseForAndRemove(unsigned char pcommand,
								unsigned char * retparam, int & retprmsize)
{

	int retval=PARSE_NOT_FOUND,i=0,j;
	//prune the buffer's start
	while((buffer[i]!=START_FRAME)&&(i<bufferptr))
		i++;
	if(i!=0)
		Remove(0,i-1);

	i=1;
	while((buffer[i]!=END_FRAME)&&(i<bufferptr))
	{
		if(buffer[i]==START_FRAME)
		{
			Remove(0,i-1);
			i=1;
		}
		else
			i++;
	}


	//find indexes i and j for commands
	for(i=0;i<bufferptr;i++)
	{
		if(buffer[i]==START_FRAME)
		{
			for(j=i+1;j<bufferptr;j++)
			{
				if(buffer[j]==END_FRAME)
					break;
				if(buffer[j]==START_FRAME)
					break;
			}
			if(buffer[j]==END_FRAME)
			{
				//by now we have found i and j
				unsigned char convbuff[2000];
				int csize=j-i-1;
				for(int k=i+1;k<j;k++)
					convbuff[k-i-1]=buffer[k];
				UnHamming(convbuff,csize);
				csize/=2;
				if(csize>0)
				{
					if(convbuff[0]==pcommand)
					{
						for(int k=0;k<csize;k++)
							retparam[k]=convbuff[k];
						retprmsize=csize;
						Remove(i,j);
						return csize;
					}
				}
			}
		}
	}

	return retval;
}